'Program:   Sites to Visit
'Version:   1.01
'History:
'           1.01 - 16th Dec 97
'           Added a SETUP Dialog and an INI file
'           Added a credit to Liberty Basic on the output HTM page
'           Made program a little more robust (I hope)
'           Improved some code (used some LB builtin facilities that I just noticed)
'           1.00 - 15th Dec 97
'           Downloaded LB on the 14th Dec and wrote this in one day!
'           (Hope it doesnt show too much)
'Purpose:   Create a list of WWW sites to be visited without puting them
'           in the bookmarks of the Browser
'Output:    A HTML page that can be set as the Home page of your browser.
'Language:  Written for use with Liberty Basic
'Author:    brosco@orac.net.au    (I will welcome any suggestions/comments/criticisms)
'HomePage:  http://members.tripod.com/~Brosco      (Favourites and Free)
'******************************************************************************************

    dim Url$(100)           'Define system variables
    dim Desc$(100)
    fname$ = "sites2v.htm"
    fs2v$ = "sites2v.s2v"
    iStartMin = -1
    iOnTop = -1
    iIniExists = 0

    gosub [LoadIni]
    if iIniExists = 0 then gosub [SitesSetup]
    gosub [DefineMain]      'Define Main Window



[StartOver]        ' Open file to output the URLs
    open fs2v$ for append as #outx

[Input]            'now stop and wait
    input aVar$
    goto [quit]

[AddClick]         'ADD! was clicked.  Get the contents of the entry field


    'get the contents from the textbox
    print #main.url, "!contents?"
    input #main.url, aUrl$
    print #main.desc, "!contents?"
    input #main.desc, aDesc$ 

    if aUrl$ = "" then
        notice "Not Added!" + chr$(13) + "You must enter a URL."
        print #main.url, "!setfocus"
        goto [Input]
    end if

    'save the URL to the file
    print #outx, aUrl$
    print #outx, aDesc$ 

    'Clear the textbox
    print #main.url, ""
    print #main.desc, ""
    print #main.url, "!setfocus"

    goto [Input]

[ListClick]       ' List the Current Sites
    gosub [LoadSites]
    gosub [DisplaySites]
    print #main.url, "!setfocus"

    goto [StartOver]

[ClearClick]      'Clear the current site list
    confirm "This will CLEAR your Sites-to-Visit list! Continue?"; answer$
    if answer$ = "no" then [Input]
    close #outx
    open fs2v$ for output as #outx
    print #main.url, "!setfocus"
    goto [Input]


[HTMLClick]       'Create HTM code for the sites in the list
    gosub [LoadSites]
    open fname$ for output as #fhtm
    gosub [writePrologue]
    gosub [writeBody]
    gosub [writeEpilogue]
    close #fhtm

    notice "Create HTML" + chr$(13) + " Sites have been successfully created as: " + fname$
    print #main.url, "!setfocus"
    goto [StartOver]

[SetupClick]        'Configure System Defaults
    gosub [SitesSetup]
    if iOnTop = -1 then
        gosub [OnTop]
    else
        gosub [NotOnTop]
    end if
    goto [Input]

[HelpClick]         ' Display Help Info
    'new form (less code and much faster)
    open "sites2v.txt" for input as #fhelp
    WindowWidth = 550
    WindowHeight = 450
    texteditor #whelp.te,  5, 5, 540, 800
    open "Help - Sites to Visit" for text as #whelp
    print #whelp, "!trapclose [CloseHelp]";
    'see how we specify the file handle instead of a string variable
    print #whelp.te, "!contents #fhelp";
[WaitHelp]
    input aVar$
    goto [WaitHelp]
[CloseHelp]
    close #whelp
    close #fhelp
    goto [Input]



[ExitClick]         ' Exit from the program
[quit]
    'Close output file
    close #outx

    'now close the window
    close #main

    end
'***********************************************************************
'*****         SubRoutines                                       *******
'***********************************************************************

[LoadIni]           ' Load program defaults
    open "sites2v.ini" for input as #fini
    if eof(#fini) = -1 then [CloseIni]
    input #fini, iOnTop, iStartMin, fname$
    iIniExists = -1
[CloseIni]
    close #fini
    return

[DefineMain]        'Define the main window

    WindowWidth = 607
    WindowHeight = 130

    nomainwin

    statictext #main.statictext1, "Site URL", 30, 16, 64, 20
    textbox #main.url, 126, 11, 464, 25
    statictext #main.statictext3, "Description", 30, 45, 88, 20
    textbox #main.desc, 126, 40, 464, 25
    button #main.button5, "Add", [AddClick], UL, 5, 70, 80, 25
    button #main.button6, "List", [ListClick], UL, 90, 70, 80, 25
    button #main.button7, "Clear", [ClearClick], UL, 175, 70, 80, 25
    button #main.button8, "HTML", [HTMLClick], UL, 260, 70, 80, 25
    button #main.button8, "Help", [HelpClick], UL, 345, 70, 80, 25
    button #main.button9, "Setup", [SetupClick], UL, 430, 70, 80, 25
    button #main.button10, "Exit", [ExitClick], UL, 515, 70, 80, 25
    open "Sites to Visit" for dialog_nf as #main
    print #main, "trapclose [quit]"

    if iOnTop = -1 then gosub [OnTop]
    if iStartMin = -1 then gosub[MinimiseWindow]
    return


[OnTop]         'Keep window ONTOP
    mainH = hwnd(#main)
    toTop = (-1 or 0) 'OR the negative number with 0 to call it in an API
    flags = _SWP_NOMOVE or _SWP_NOSIZE

    open "user" for dll as #user

    calldll #user, "SetWindowPos", _
        mainH as ushort, _
        toTop as short, _
        0 as short, _
        0 as short, _
        0 as short, _
        0 as short, _
        flags as ushort, _
        result as void

    close #user
    return

[NotOnTop]         'Remove window from ONTOP
    mainH = hwnd(#main)
    toTop = 0
    flags = _SWP_NOMOVE or _SWP_NOSIZE

    open "user" for dll as #user

    calldll #user, "SetWindowPos", _
        mainH as ushort, _
        toTop as short, _
        0 as short, _
        0 as short, _
        0 as short, _
        0 as short, _
        flags as ushort, _
        result as void

    close #user
    return

[MinimiseWindow]    'Used at startup if Sites2V is to start Minimised
    open "user" for dll as #user

    h = hwnd(#main)
    calldll #user, "CloseWindow", _
        h as word, _
        result as void

    close #user
    return


[SitesSetup]        'Setup Configuration Defaults

    iSaveOntop = iOnTop     'Save defaults incase changes not saved!
    iSaveMin = iStartMin
    SaveFile$ = fname$

    WindowWidth = 550
    WindowHeight = 150
    statictext #wsetup.statictext2, "Always On Top?", 26, 16, 112, 20
    statictext #wsetup.statictext3, "Start Minimised?", 302, 16, 128, 20
    statictext #wsetup.statictext4, "HTML Filename:", 26, 51, 112, 20
    checkbox #wsetup.ontop, iOnTop, [OntopSet], [OntopReset], 142, 16, 16, 20
    checkbox #wsetup.startmin, iStartMin, [StartminSet], [StartminReset], 438, 16, 16, 20
    textbox #wsetup.fname, 142, 46, 304, 25
    button #wsetup.button8, "Browse", [BrowseClick], UL, 462, 46, 58, 25
    button #wsetup.button9, "Apply", [ApplyClick], UL, 150, 91, 58, 25
    button #wsetup.button10, "Cancel", [CancelClick], UL, 294, 91, 58, 25
    open "Setup - Sites to Visit" for graphics_nsb as #wsetup
    print #wsetup, "trapclose [SetupQuit]"

    print #wsetup.ontop, "setfocus"
    if iOnTop = -1 then
        print #wsetup.ontop, "set"
    else
        print #wsetup.ontop, "reset"
    end if
    if iStartMin = -1 then
        print #wsetup.startmin, "set"
    else
        print #wsetup.startmin, "reset"
    end if

    print #wsetup.fname, fname$

[SetupWait]
    input avar$
    goto [SetupWait]

[OntopSet]
    iOnTop = -1
    goto [SetupWait]
[OntopReset]
    iOnTop = 0
    goto [SetupWait]
[StartminSet]
    iStartMin = -1
    goto [SetupWait]
[StartminReset]
    iStartMin = 0
    goto [SetupWait]
[BrowseClick]
    filedialog "Save HTM as:","*.htm",fname$
    print #wsetup.fname, fname$
    goto [SetupWait]

[ApplyClick]
    print #wsetup.fname, "!contents?"
    input #wsetup.fname, fname$ 

    open "sites2v.ini" for output as #fini
    print #fini, iOnTop
    print #fini, iStartMin
    print #fini, fname$
    close #fini
    notice "Setup Saved!" + chr$(13) + "Ontop & Start Minimised will apply next restart."
    goto [SetupQuit]

[CancelClick]
    iOnTop = iSaveOntop
    iStartMin =iSaveMin
    fname$ = SaveFile$

[SetupQuit]
    close #wsetup
    return


[LoadSites]       'Load saved sites to memory
    close #outx
    iUrl = 0
    open fs2v$ for input as #in
[ReadLoop]
    if eof(#in) = -1 then [ThatsAll]
    iUrl = iUrl + 1
    if iUrl > 100 then [TooMany]
    line input #in, aUrl$
    line input #in, aDesc$
    Url$(iUrl) = aUrl$
    Desc$(iUrl) = aDesc$
    goto [ReadLoop]
[ThatsAll]
    close #in
    return
[TooMany]
    close #in
    notice "Site list truncated!" + chr$(13) + "You have more than 100 sites in your list!"
    return

[DisplaySites]          ' Display saved sites in a window

    WindowWidth = 550
    WindowHeight = 450
    open "Sites List" for text as #slist
    print #slist, "!trapclose [CloseSites]";
    for i = 1 to iUrl
    print #slist, Url$(i)
    print #slist, Desc$(i)
    print #slist,""
    next i

    print #slist,"         ";
    print #slist, iUrl;
    print #slist, " sites currently in the list."


[wait]
    input avar$
    goto [wait]

[CloseSites]
    close #slist
    return

[writeEpilogue]      ' Routines for writing HTML code
    print #fhtm,"</TABLE>"
    print #fhtm, "<HR><CENTER>"
    print #fhtm,"<CENTER><P>Software is provided as Freeware.<BR>Copyright 1997<BR>Brosco Home Computer Services</P> </CENTER>"
    print #fhtm,"<CENTER><A HREF='http://world.std.com/~carlg/basic.html'>Sites-to-Visit is written in Liberty Basic V1.4 - Windows Programming made EASY!</A></CENTER>"
    print #fhtm,"</BODY></HTML>"
    return

[writeBody]
    for i = 1 to iUrl
    print #fhtm, "<TR><TD><A HREF='";
    print #fhtm, Url$(i);
    print #fhtm, "'>";
    print #fhtm, Desc$(i);
    print #fhtm, "</A></TD></TR>"
    next i
    return

[writePrologue]
    print #fhtm, "<HTML> <HEAD><TITLE> Sites to Visit</TITLE></HEAD> "
    print #fhtm, "<BODY>"
    print #fhtm, "<CENTER> <H1>Sites to Visit</H1>Software by <A href='mailto:brosco@orac.net.au'>Brosco</A></CENTER>"
    print #fhtm, "Visit Brosco's Home: <A href='http://members.tripod.com./~Brosco'>Favourites and Free - Software - Internet Services - Tips and Tricks, etc.</A></CENTER><P>"
    print #fhtm, "<CENTER><HR>"
    print #fhtm, "<TABLE>"
    return
'***************************** Here endith the program! ***************


